;######################################################################## 
;######################################################################## 
;######################################################################## 
TWI_INI:
	; TWI TWCR 				Control-REGISTER	
	ldi temp, 1<<TWINT|1<<TWEA|0<<TWSTA|0<<TWSTO|0<<TWWC|1<<TWEN|1<<TWIE
	out TWCR,temp
	; TWI TWAR (nur SLAVE) 	Adress-Register		
	ldi temp,(TWI_SLAVE_ADRESSE<<TWA0 | TWI_GENERAL_CALL_ENABLE<<TWGCE)
	out TWAR,temp
ret
; #############################################################################
; #############################################################################
; #############################################################################
TWI_ERROR:
	cbi PORTB, LED_B_ROT	; an	

	; STOP		
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	; FEHLERPRFUNG
	in temp, TWSR
	andi temp,0b11111000
	cpi  temp,0b11111000
	brne TWI_ERROR_SCHWER	
	ret
;--------------------------------------------------------------
TWI_ERROR_SCHWER:


ret
; #############################################################################
; #############################################################################
; #############################################################################
;																				
; TWI INTERRUPPT-Routine														
;																				
TWSI:
	push TEMP
	in TEMP,SREG	     ; Schreiben von  SREG  im Stack (KOPIE)	
	push temp
	push temp1           ; temp1 auf dem Stack sichern            	
;-------------------------------------------------------------------------------
	in temp, TWSR		; TWI- Status-Register abfragen							
	andi temp, 0xF8		; Bit0...2 ausblenden (Prescaler und Reserve-Bit)		
;-------------------------------------------------------------------------------
TWSI_TWSR_AUSWERTEN:
	;	vergleich		
	cpi temp, TW_SR_SLA_ACK			 	; x60
	breq TWSI_TW_SR_SLA_ACK
	cpi temp, TW_SR_ARB_LOST_SLA_ACK 	; x68
	breq TWSI_TW_SR_ARB_LOST_SLA_ACK
	cpi temp, TW_SR_GCALL_ACK			; x70
	breq TWSI_TW_SR_GCALL_ACK
	cpi temp, TW_SR_ARB_LOST_GCALL_ACK	; x78
	breq TWSI_TW_SR_ARB_LOST_GCALL_ACK
	cpi temp, TW_SR_DATA_ACK      		; x80
	breq TWSI_TW_SR_DATA_ACK      	
	cpi temp, TW_SR_DATA_NACK      		; x88
	breq TWSI_TW_SR_DATA_NACK
	cpi temp, TW_SR_GCALL_DATA_ACK   	; x90
	breq TWSI_TW_SR_GCALL_DATA_ACK   
	cpi temp, TW_SR_GCALL_DATA_NACK		; x98
	breq TWSI_TW_SR_GCALL_DATA_NACK
	cpi temp, TW_SR_STOP        		; xA0
	breq TWSI_TW_SR_STOP        	
; 	
	cpi temp, TW_ST_SLA_ACK        		; 0xA8
	breq TWSI_TW_ST_SLA_ACK	
	cpi temp, TW_ST_ARB_LOST_SLA_ACK	; 0xB0
	breq TWSI_TW_ST_ARB_LOST_SLA_ACK
	cpi temp, TW_ST_DATA_ACK      		; 0xB8
	breq TWSI_TW_ST_DATA_ACK
	cpi temp, TW_ST_DATA_NACK      		; 0xC0
	breq TWSI_TW_ST_DATA_NACK
	cpi temp, TW_ST_LAST_DATA      		; 0xC8
	breq TWSI_TW_ST_LAST_DATA 
	cpi temp, TW_NO_INFO        		; 0xF8
	breq TWSI_TW_NO_INFO
	cpi temp, TW_BUS_ERROR        		; 0x00 (Error)
	breq TWSI_TW_BUS_ERROR 
	rjmp TWSI_ANTWORT					; nicht behandelte Status-Zustnde	

; SLAVE RECEIVER						
TWSI_TW_SR_SLA_ACK:						; x60 ("SLA+W" wurde empfangen) 				
	; START				
	; ZEIGER auf NULL	
	STS(adr_DATEN_ZEIGER),NULL
	rjmp TWSI_ANTWORT
TWSI_TW_SR_ARB_LOST_SLA_ACK:			; x68 (Arbitration verloren)					
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_ACK:					; x70 ("General Call" wurde empfangen)			
	; START "General Call"		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_ARB_LOST_GCALL_ACK:			; x78 (Arbitration verloren)					
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_ACK:					; x80 ("SLA+W"-Datenbyte wurden empfangen) 		
	; DATA				
	in temp1, TWDR		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_NACK:      				; x88 (die vorher adressierten (SLA+W) Daten wurden empfangen; ACK wurde nicht zurckgesedet
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_DATA_ACK:				; x90 ("General Call"-Datenbyte wurden empfangen)	
	; DATA				
	in temp1, TWDR		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_DATA_NACK:				; x98 (die vorher adressierten (General call) Daten wurden empfangen;  ACK wurde nicht zurckgesendet	
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_STOP:						; xA0 (STOP oder Repead-START wurde empfangen)
	; STOP				
	rjmp TWSI_ANTWORT
;	SLAVE TRANSMITTER					
TWSI_TW_ST_SLA_ACK:						; xA8 (SLA+R wurde empfangen) + ACK 
	; ZEIGER auf NULL
	STS(adr_DATEN_ZEIGER),NULL
	; DATA			
	rcall TWI_SLAVE_DATEN_AUSGEBEN
	OUT TWDR, temp1						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_ARB_LOST_SLA_ACK:			; xB0 (Arbitration verlor SLA+R/W als MASTER, ACK wurde zurckgesendet)	
	rjmp TWSI_ANTWORT
TWSI_TW_ST_DATA_ACK:					; xB8 (DATEN wurden bertragen) + ACK 	
	; DATA			
	rcall TWI_SLAVE_DATEN_AUSGEBEN
	OUT TWDR, temp1						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_DATA_NACK:					; xC0 (TWDR ist bertragen worden;  ACK ist NICHT empfangen worden
	ldi temp,'C'	
	OUT TWDR, temp						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_LAST_DATA:					; xC8 (Letztes Datenbyte in TWDR ist bertragen worden (TWEA = "0");  Ack ist empfangen worden
	ldi temp,'D'
	OUT TWDR, temp						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
	; NO INFO		
TWSI_TW_NO_INFO:						; xF8 (Keine relevanten Zustandinformationen vorhanden;  TWINT = "0" keine TWDR-Ttigkeit 
	rjmp TWSI_ANTWORT

; ERROR									
TWSI_TW_BUS_ERROR:						; x00 (Bus-Error wegen ungltige STARToder STOP BEDIgung; keine TWDR-Ttigkeit 
	rcall TWI_ERROR	
	rjmp TWSI_ANTWORT
;--------------------------------------
TWSI_ANTWORT:	
	; ANTWORTEN							
	ldi temp, 1<<TWINT|1<<TWEA|1<<TWEN|1<<TWIE
	out TWCR,temp
;--------------------------------------
		pop temp1
		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG
		pop	TEMP				; LESEN von SREG vom STACK (KOPIE)
reti
; #############################################################################
; #############################################################################
; #############################################################################
; Die DATEN an MASTER senden												   
;																			   
; OUT: temp1 <= DATEN														   
;																			   
TWI_SLAVE_DATEN_AUSGEBEN:
	; ZEIGER laden		
	LDS temp,(adr_DATEN_ZEIGER)
	; +1 
	inc temp
	; ZEIGER speichern	
	STS(adr_DATEN_ZEIGER),temp
	; -1
	dec temp
	; vergleich			
	cpi temp,0
	breq TWI_SLAVE_DATEN_AUSGEBEN_0
	cpi temp,1
	breq TWI_SLAVE_DATEN_AUSGEBEN_1
	cpi temp,2
	breq TWI_SLAVE_DATEN_AUSGEBEN_2
	cpi temp,3
	breq TWI_SLAVE_DATEN_AUSGEBEN_3
	cpi temp,4
	breq TWI_SLAVE_DATEN_AUSGEBEN_4
	cpi temp,5
	breq TWI_SLAVE_DATEN_AUSGEBEN_5
	cpi temp,6
	breq TWI_SLAVE_DATEN_AUSGEBEN_6
	cpi temp,7
	breq TWI_SLAVE_DATEN_AUSGEBEN_7
	cpi temp,8
	breq TWI_SLAVE_DATEN_AUSGEBEN_8
	cpi temp,9
	breq TWI_SLAVE_DATEN_AUSGEBEN_9
	cpi temp,10
	breq TWI_SLAVE_DATEN_AUSGEBEN_10

	;NULL
	clr temp1
	ret

TWI_SLAVE_DATEN_AUSGEBEN_0:
	LDS temp1,(adr_DCF_GUELTIG)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_1:
	LDS temp1,(adr_DCF_ZEIGER)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_2:
	LDS temp1,(adr_DCF_STATUS)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_3:
	LDS temp1,(adr_ss)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_4:
	LDS temp1,(adr_mm)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_5:
	LDS temp1,(adr_hh)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_6:
	LDS temp1,(adr_TAG)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_7:
	LDS temp1,(adr_MONAT)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_8:
	LDS temp1,(adr_JAHR)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_9:
	LDS temp1,(adr_WOCHENTAG)
	ret
TWI_SLAVE_DATEN_AUSGEBEN_10:
	LDS temp1,(adr_DCF_SOMMERZEIT)
ret
; #############################################################################
; #############################################################################
; #############################################################################
